# Download data, train model, upload artifacts to Flywheel for Swarm HPE POC

Instructions to run HPE Swarm can be found in the 
[HPE_SWARM_INSTRUCTIONS.md](./HPE_SWARM_INSTRUCTIONS.md) doc.  

## Requirements

* Python 3.7+
* `pip install -r requirements.txt`
* A valid Flywheel API key to [federation.uat.flywheel.io](federation.uat.flywheel.io)


## Usage


### Download raw data on SL node

Flywheel at [federation.uat.flywheel.io](federation.uat.flywheel.io) hosts 2 projects
containing image/label that need to be downloaded to the SL Nodes for training. Each
project contains about 11k training+validation image/label.

On SL node <N>, download Flywheel project `ml/FL-node<N>>` 
```bash
./download_data.py --api-key <api-key> --fw-project-lu ml/FL-node<N> --dataview-label "HPE swarm" --output-dir raw-data
```

For testing purpose, you can download a much tinier version with only 80ish dataset using
the Flywheel project `ml/FL-node<N>-tiny`:
```bash
./download_data.py --api-key <api-key> --fw-project-lu ml/FL-node<N>-tiny --dataview-label "HPE swarm" --output-dir raw-data
```

### Training

On the SL node <N> for <M> epochs, train:

```bash
./train.py --data-dir raw-data --num-epoch <M> --out-dir ./artifacts
```

The output model will be saved in `output/model.pt`

For testing purpose you can disable swarm training running:
```bash
./train.py --data-dir raw-data --num-epoch <M> --no-swarm --out-dir ./artifacts
```

The `models.pt` output as well as the training log will be saved in the `./artifacts` folder  


### Upload training artifacts back to Flywheel

On the SL node, run: 

```bash
./upload_artifacs --api-key <api-key> --fw-project-lu ml/FL-node<N> --dir ./output
```

To upload the artifact generated by the training run back to the Flywheel project as
an analysis container. 